.486
.MODEL FLAT,C

BPAWN EQU 10
BROOK EQU 13
BQUEEN EQU 14
BKING EQU 15
BKNIGHT EQU 12
BBISHOP EQU 11

WPAWN EQU 2
WROOK EQU 5 
WQUEEN EQU 6
WKING EQU 7
WKNIGHT EQU 4
WBISHOP EQU 3

EMPTY EQU 0

.CODE


AddAttackMoveC PROC NEAR

PUBLIC AddAttackMoveC

           push esi
           push eax
           
           mov esi, dword ptr[edx + 4]   ; esi = Movelist.numAttackmoves
           inc dword ptr[edx + 4]        ; Movelist.numAttackmoves += 1
           sub eax, edi                  ; dst 
		   inc esi
           shl eax, 8                    ; dst << 8
		   add eax, ecx					 ; add (src + piecenum<<16)
           mov dword ptr[edx + esi * 4 + 12], eax ; &Movelist + 12 start of attack moves
           
           pop eax
           pop esi
           ret

AddAttackMoveC ENDP

FindAMovesBlackKnightasm PROC NEAR AA:DWORD, BB:DWORD, CC:DWORD, EE:DWORD
PUBLIC FindAMovesBlackKnightasm

; edx = Movelist pointer eax = Boardsrc pointer, ecx = src + type << 16, edi = boardstart
; check directions 8, 12, 19, 21, -8, -12, -19, -21
           pusha
		   mov edx, AA
		   mov edi, BB
		   mov eax, CC
		   mov ecx, EE
           
           xor ebx, ebx                  ; 0 out ebx
           add eax, 8
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           je knightnext1
           cmp ebx, 8
           jae knightnext1
           CALL AddAttackMoveC
    
           knightnext1:
           add eax, 4
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           je knightnext2
           cmp ebx, 8
           jae knightnext2
           CALL AddAttackMoveC
           
           knightnext2:
           add eax, 7
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           je knightnext3
           cmp ebx, 8
           jae knightnext3
           CALL AddAttackMoveC
    
           knightnext3:
           add eax, 2
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           je knightnext4
           cmp ebx, 8
           jae knightnext4
           CALL AddAttackMoveC
           
           knightnext4:
           sub eax, 29
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           je knightnext5
           cmp ebx, 8
           jae knightnext5
           CALL AddAttackMoveC
    
           knightnext5:
           sub eax, 4
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           je knightnext6
           cmp ebx, 8
           jae knightnext6
           CALL AddAttackMoveC
           
           knightnext6:
           sub eax, 7
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           je knightnext7
           cmp ebx, 8
           jae knightnext7
           CALL AddAttackMoveC
    
           knightnext7:
           sub eax, 2
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           je knightnext8
           cmp ebx, 8
           jae knightnext8
           CALL AddAttackMoveC
           
           knightnext8:
           
           popa
           
           ret
           
FindAMovesBlackKnightasm ENDP

FindAMovesBlackKingasm PROC NEAR AA:DWORD, BB:DWORD, CC:DWORD, EE:DWORD
PUBLIC FindAMovesBlackKingasm

; edx = Movelist pointer eax = Boardsrc pointer, ecx = src + type << 16, edi = boardstart
; 1, 9, 10, 11, -1 , -9, -10, -11
           pusha
		   mov edx, AA
		   mov edi, BB
		   mov eax, CC
		   mov ecx, EE
           
           xor ebx, ebx                  ; 0 out ebx
           add eax, 1
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           je kingnext1
           cmp ebx, 8
           jae kingnext1
           CALL AddAttackMoveC
    
           kingnext1:
           add eax, 8
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           je kingnext2
           cmp ebx, 8
           jae kingnext2
           CALL AddAttackMoveC
           
           kingnext2:
           add eax, 1
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           je kingnext3
           cmp ebx, 8
           jae kingnext3
           CALL AddAttackMoveC
    
           kingnext3:
           add eax, 1
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           je kingnext4
           cmp ebx, 8
           jae kingnext4
           CALL AddAttackMoveC
           
           kingnext4:
           sub eax, 12
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           je kingnext5
           cmp ebx, 8
           jae kingnext5
           CALL AddAttackMoveC
    
           kingnext5:
           sub eax, 8
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           je kingnext6
           cmp ebx, 8
           jae kingnext6
           CALL AddAttackMoveC
           
           kingnext6:
           sub eax, 1
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           je kingnext7
           cmp ebx, 8
           jae kingnext7
           CALL AddAttackMoveC
    
           kingnext7:
           sub eax, 1
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           je kingnext8
           cmp ebx, 8
           jae kingnext8
           CALL AddAttackMoveC
           
           kingnext8:
           
           popa
           ret
           
FindAMovesBlackKingasm ENDP

FindAMovesBlackPawnasm PROC NEAR AA:DWORD, BB:DWORD, CC:DWORD, EE:DWORD
PUBLIC FindAMovesBlackPawnasm
           pusha
		   mov edx, AA
		   mov edi, BB
		   mov eax, CC
		   mov ecx, EE
                      
           xor ebx, ebx                  ; 0 out ebx

           add eax, 9					; Attack + 9
           mov bl, byte ptr[eax]     
           sub eax, edi              
           cmp al, byte ptr[edi + 123] ; en passant
           je pawn3
           
		   cmp ebx, 0
		   je pawnnext3
           cmp ebx, 8                  ; normal capture 
           jae pawnnext3
           pawn3:
           add eax, edi              ; Back to eax = &square
           CALL AddAttackMoveC
           sub eax, edi

           pawnnext3:                ; Attack + 11

           add eax, edi
           add eax, 2
           mov bl, byte ptr[eax]
           sub eax, edi  ; en passant
           cmp al, byte ptr[edi + 123]  ; en passant
           je pawn4
           
		   cmp ebx, 0
		   je pawnnext4
           cmp ebx, 8                   ; normal capture
           jae pawnnext4
           pawn4:
           add eax, edi            ; Back to eax = &square
           CALL AddAttackMoveC

           pawnnext4:
           
           popa
           ret
           
FindAMovesBlackPawnasm ENDP

                                                ; devalue queens moves?
FindAMovesBlackQueenasm PROC NEAR AA:DWORD, BB:DWORD, CC:DWORD, EE:DWORD
PUBLIC FindAMovesBlackQueenasm
           pusha
		   mov edx, AA
		   mov edi, BB
		   mov eax, CC
		   mov ecx, EE
           
           mov esi, eax
          
           mov ebx, 1             ; Check direction 1
           mov eax, esi
           
           qagain1:
           add eax, ebx
           cmp byte ptr[eax], 0
           je qagain1
           
           cmp byte ptr [eax], 8
           jae qnext1
           CALL AddAttackMoveC
           
           qnext1:
           mov ebx, -1             
           mov eax, esi
           
           qagain2:
           add eax, ebx
           cmp byte ptr[eax], 0
           je qagain2
           
           cmp byte ptr [eax], 8
           jae qnext2
           CALL AddAttackMoveC
                
         
           qnext2:
           mov ebx, 10             
           mov eax, esi
           
           qagain3:
           add eax, ebx
           cmp byte ptr[eax], 0
           je qagain3
           
		   cmp byte ptr [eax], 8
           jae qnext3
           CALL AddAttackMoveC
           
           qnext3:
           mov ebx, -10
           mov eax, esi
           
           qagain4:
           add eax, ebx
           cmp byte ptr[eax], 0
           je qagain4
           
		   cmp byte ptr [eax], 8
           jae qnext4
           CALL AddAttackMoveC
                 
		   qnext4:
           mov ebx, 9             
           mov eax, esi
           
           qagain5:
           add eax, ebx
           cmp byte ptr[eax], 0
           je qagain5
           
		   cmp byte ptr [eax], 8
           jae qnext5
           CALL AddAttackMoveC
                
           
           qnext5:
           mov ebx, -9             
           mov eax, esi
           
           qagain6:
           add eax, ebx
           cmp byte ptr[eax], 0
           je qagain6
           
		   cmp byte ptr [eax], 8
           jae qnext6
           CALL AddAttackMoveC
                          
           qnext6:
           mov ebx, 11             
           mov eax, esi
           
           qagain7:
           add eax, ebx
           cmp byte ptr[eax], 0
           je qagain7
           
		   cmp byte ptr [eax], 8
           jae qnext7
           CALL AddAttackMoveC
           
           qnext7:
           mov ebx, -11             
           mov eax, esi
           
           qagain8:
           add eax, ebx
           cmp byte ptr[eax], 0
           je qagain8
           
		   cmp byte ptr [eax], 8
           jae qnext8
           CALL AddAttackMoveC           
           
           qnext8:
           
           popa
           ret                                                       
           
FindAMovesBlackQueenasm ENDP

FindAMovesBlackRookasm PROC NEAR AA:DWORD, BB:DWORD, CC:DWORD, EE:DWORD
PUBLIC FindAMovesBlackRookasm
           pusha
		   mov edx, AA
		   mov edi, BB
		   mov eax, CC
		   mov ecx, EE

           mov esi, eax
          
           mov ebx, 1             ; Check direction 1
           mov eax, esi
           
           ragain1:
           add eax, ebx
           cmp byte ptr[eax], 0
           je ragain1
           
		   cmp byte ptr [eax], 8
           jae rnext1
           CALL AddAttackMoveC
           
           rnext1:
           mov ebx, -1             
           mov eax, esi
           
           ragain2:
           add eax, ebx
           cmp byte ptr[eax], 0
           je ragain2

		   cmp byte ptr [eax], 8
           jae rnext2
           CALL AddAttackMoveC
                
           rnext2:
           mov ebx, 10             
           mov eax, esi
           
           ragain3:
           add eax, ebx
           cmp byte ptr[eax], 0
           je ragain3
           
		   cmp byte ptr [eax], 8
           jae rnext3
           CALL AddAttackMoveC
           
           rnext3:
           mov ebx, -10
           mov eax, esi
           
           ragain4:
           add eax, ebx
           cmp byte ptr[eax], 0
           je ragain4
           
		   cmp byte ptr [eax], 8
           jae rnext4
           CALL AddAttackMoveC
            
           rnext4:
           
           popa
           ret
                                               
          
FindAMovesBlackRookasm ENDP

 
FindAMovesBlackBishopasm PROC NEAR AA:DWORD, BB:DWORD, CC:DWORD, EE:DWORD
PUBLIC FindAMovesBlackBishopasm
           pusha
		   mov edx, AA
		   mov edi, BB
		   mov eax, CC
		   mov ecx, EE
           
           mov esi, eax
          
           mov ebx, 9             ; Check direction 1
           mov eax, esi
           
           bagain1:
           add eax, ebx
           cmp byte ptr[eax], 0
           je bagain1
           
		   cmp byte ptr [eax], 8
           jae bnext1
           CALL AddAttackMoveC
           
           bnext1:
           mov ebx, -9
           mov eax, esi
           
           bagain2:
           add eax, ebx
           cmp byte ptr[eax], 0
           je bagain2
           
		   cmp byte ptr [eax], 8
           jae bnext2
           CALL AddAttackMoveC
               
           bnext2:
           mov ebx, 11
           mov eax, esi
         
           bagain3:
           add eax, ebx
           cmp byte ptr[eax], 0
           je bagain3
           
		   cmp byte ptr [eax], 8
           jae bnext3
           CALL AddAttackMoveC
           
           bnext3:
           mov ebx, -11
           mov eax, esi
           
           bagain4:
           add eax, ebx
           cmp byte ptr[eax], 0
           je bagain4
           
		   cmp byte ptr [eax], 8
           jae bnext4
           CALL AddAttackMoveC
            
           bnext4:
           
           popa
           ret
           
FindAMovesBlackBishopasm ENDP
END

       
