#define INWM_READDATA 5789
#define INWM_CONNECTION 5790
#define INWM_ICC_READDATA 5791
#define INWM_SPEC_READDATA 5792 // 5792 to 5792 + MAXCLIENTS

#define MAXCLIENTS 48
#define MAXTABLES 8
#define HOLDSIZE 3200

#define SC_ALL -1

enum { SC_NULL, SC_TABLE, SC_CHAT, SC_INFO, SC_MOVED, SC_NAME, SC_NEW, SC_DRAW, SC_RESIGN, SC_DISC, SC_SETUP,
	   SC_TIMEUP, SC_TRANSCRIPT, SC_STARTBOX, SC_CONTINUE, SC_COLOR, SC_NAMES, SC_WHITENAME, SC_BLACKNAME, SC_SPECS,
	   SC_GOSPEC, SC_TIMECONTROL, SC_DISCONNECT };

void InitializeSockets (void);

int OpenSocket ( char ip[], unsigned short usPort );
int CloseSocket();
int SendData ( char *data, int nLen, int nType, int nClient );

void scNetMessage ( char cType, char cInfo);
void scNetMessageS ( char cType, char *sInfo);

int AcceptConnection( void );
int WaitForConnect ( unsigned short usPort);
int CloseListenSocket ( );

void scNetSendMove ( void );
void scNetNewGameRequest ( void );
struct SBoard;
void scNetOppMove ( char *sMove, SBoard &Board );
void NetMessageWindow( HWND hwnd, unsigned long Message);

void SendSetupInfo (char type, char info);
void SendSetupInfo (char type, char info, char info2);
void SetupInfoTime (	int Minutes, int Seconds );
void scSendName( char *sName );
void scNetSendTranscript ( );


void ReceiveDataServer ( char msg, char * string, int nClient );
void ReceiveDataClient ( char msg, char * string );
int ReceiveClientMessage ( int nClient );
int ReceiveSetupInfo (char acReadBuffer[] );
int ReceiveDataMessage ( char *pOutBuffer, int nClient, int bRead );

int RemoveClient ( int nClient );

int DisplayMyIP( );
// global Data
extern int bServer;


/*int SendICCString ( char *string );
int ICCReceiveDataMessage ( char *pOutBuffer );
void scGotMove ( );*/