#include <windows.h>
#include <stdio.h>
#include <time.h>

#include "data.h"
#include "moves.h"
#include "search.h"
#include "see.h"

// ------------------------
// Quiesce Square
//
// This code looks ugly but it's mostly cut&paste
// ------------------------
//
// Send in White's Lowest Valued Attacker
//
int CAttackList::Generate ( unsigned char Board[], int sq )
{
m_Sq = sq;
m_nWAttacks = 0;
m_nBAttacks = 0;

if (Board [ sq+11 ] == WPAWN) {AddAttack (Board, sq+11 ); }
if (Board [ sq+9  ] == WPAWN) {AddAttack (Board, sq+9 );  }

if (Board [ sq-11 ] == BPAWN) {AddAttack (Board, sq-11 ); }
if (Board [ sq-9  ] == BPAWN) {AddAttack (Board, sq-9 );  }

if ((Board [ sq-21 ]&7) == WKNIGHT ) {AddAttack (Board, sq-21 ); }
if ((Board [ sq-19 ]&7) == WKNIGHT ) {AddAttack (Board,  sq-19 ); }
if ((Board [ sq-12 ]&7) == WKNIGHT ) {AddAttack (Board,  sq-12 ); }
if ((Board [ sq-8  ]&7) == WKNIGHT ) {AddAttack (Board,  sq-8  ); }
if ((Board [ sq+8  ]&7) == WKNIGHT ) {AddAttack (Board,  sq+8  ); }
if ((Board [ sq+12 ]&7) == WKNIGHT ) {AddAttack (Board,  sq+12 ); }
if ((Board [ sq+19 ]&7) == WKNIGHT ) {AddAttack (Board,  sq+19 ); }
if ((Board [ sq+21 ]&7) == WKNIGHT ) {AddAttack (Board,  sq+21 ); }


int dir = -11;
register int tempSq = sq + dir;
while (Board [tempSq] == EMPTY)
	tempSq+=dir;
if ((Board [ tempSq ]&7) == WBISHOP || (Board [ tempSq ]&7) == WQUEEN)  
	{AddAttack (Board,  tempSq);}

dir = -9;
tempSq = sq + dir;
while (Board [tempSq] == EMPTY)
	tempSq+=dir;
if ((Board [ tempSq ]&7) == WBISHOP || (Board [ tempSq ]&7) == WQUEEN)  
	{AddAttack (Board,  tempSq);}


dir = 9;
tempSq = sq + dir;
while (Board [tempSq] == EMPTY)
	tempSq+=dir;
if ((Board [ tempSq ]&7) == WBISHOP || (Board [ tempSq ]&7) == WQUEEN)  
	{AddAttack (Board,  tempSq);}


dir = 11;
tempSq = sq + dir;
while (Board [tempSq] == EMPTY)
	tempSq+=dir;
if ((Board [ tempSq ]&7) == WBISHOP || (Board [ tempSq ]&7) == WQUEEN)  
	{AddAttack (Board,  tempSq);}

dir = -10;
tempSq = sq + dir;
while (Board [tempSq] == EMPTY)
	tempSq+=dir;
if ((Board [ tempSq ]&7) == WROOK || (Board [ tempSq ]&7) == WQUEEN)  
	{AddAttack (Board,  tempSq);}

dir = -1;
tempSq = sq + dir;
while (Board [tempSq] == EMPTY)
	tempSq+=dir;
if ((Board [ tempSq ]&7) == WROOK || (Board [ tempSq ]&7) == WQUEEN)  
	{AddAttack (Board,  tempSq);}

dir = 1;
tempSq = sq + dir;
while (Board [tempSq] == EMPTY)
	tempSq+=dir;
if ((Board [ tempSq ]&7) == WROOK || (Board [ tempSq ]&7) == WQUEEN)  
	{AddAttack (Board,  tempSq);}

dir = 10;
tempSq = sq + dir;
while (Board [tempSq] == EMPTY)
	tempSq+=dir;
if ((Board [ tempSq ]&7) == WROOK || (Board [ tempSq ]&7) == WQUEEN)  
	{AddAttack (Board,  tempSq);}

if ( (Board [ sq-11 ]&7) == WKING ) {AddAttack (Board,  sq-11 ); }
if ( (Board [ sq-10 ]&7) == WKING ) {AddAttack (Board,  sq-10 ); }
if ( (Board [ sq-9  ]&7) == WKING ) {AddAttack (Board,  sq-9  ); }
if ( (Board [ sq-1  ]&7) == WKING ) {AddAttack (Board,  sq-1  ); }
if ( (Board [ sq+1  ]&7) == WKING ) {AddAttack (Board,  sq+1  ); }
if ( (Board [ sq+9  ]&7) == WKING ) {AddAttack (Board,  sq+9  ); }
if ( (Board [ sq+10 ]&7) == WKING ) {AddAttack (Board,  sq+10 ); }
if ( (Board [ sq+11 ]&7) == WKING ) {AddAttack (Board,  sq+11 ); }

return 0;
}

//
//
//
int CAttackList::DoWhiteAttack ( unsigned char Board[] )
{
int nSrcSq = 0;
int Value, nBest = 50000;

for (int i = 0; i < m_nWAttacks; i++)
	{
	Value = PieceValues [ Board [ m_WSqs[i] ] ];
	if (Value != 0 && Value < nBest) 
		{
		 nBest = Value;
		 nSrcSq = m_WSqs[i];
		}
	}
if (nSrcSq == 0) return FALSE;

Board [ m_Sq ] = Board [ nSrcSq ];
Board [ nSrcSq ] = EMPTY;

// Check For Discovered Attacks
int nDirec = acDirec [ m_Sq + (nSrcSq<<7) ];
if (nDirec != 0) 
	{
	int tempSq = m_Sq+nDirec;
	while (Board[tempSq] == EMPTY) tempSq+=nDirec;
	if ( HoriDir [ nDirec + 12 ] )
		{if (Board [ tempSq ] == WROOK || Board [ tempSq ] == WQUEEN || Board [ tempSq ] == BROOK || Board [ tempSq ] == BQUEEN)
			AddAttack (Board,  tempSq);
		}
	else
		{
		if (Board [ tempSq ] == WBISHOP || Board [ tempSq ] == WQUEEN || Board [ tempSq ] == BBISHOP || Board [ tempSq ] == BQUEEN)  
			AddAttack (Board,  tempSq);
		}
	}

return TRUE;
}
//
//
//
int CAttackList::DoBlackAttack ( unsigned char Board[] )
{
int nSrcSq = 0;
int Value, nBest = -50000;

for (int i = 0; i < m_nBAttacks; i++)
	{
	Value = PieceValues [ Board [ m_BSqs[i] ] ];
	if (Value != 0 && Value > nBest) 
		{
		 nBest = Value;
		 nSrcSq = m_BSqs[i];
		}
	}
if (nSrcSq == 0) return FALSE;

Board [ m_Sq ] = Board [ nSrcSq ];
Board [ nSrcSq ] = EMPTY;

// Check For Discovered Attacks
int nDirec = acDirec [ m_Sq + (nSrcSq<<7)];
if (nDirec != 0) 
	{
	int tempSq = m_Sq+nDirec;
	while (Board[tempSq] == EMPTY) tempSq+=nDirec;
	if ( HoriDir [ nDirec + 12 ] )
		{if (Board [ tempSq ] == WROOK || Board [ tempSq ] == WQUEEN || Board [ tempSq ] == BROOK || Board [ tempSq ] == BQUEEN)
			AddAttack (Board,  tempSq);
		}
	else
		{
		if (Board [ tempSq ] == WBISHOP || Board [ tempSq ] == WQUEEN || Board [ tempSq ] == BBISHOP || Board [ tempSq ] == BQUEEN)  
			AddAttack (Board,  tempSq);
		}
	}

return TRUE;
}

// ----------------------------
//
// Static Exchange Evaluation. Tests the outcome of attacks on one square
//
// ----------------------------
int CAttackList::SEE ( char Color, short value, SBoard &TempBoard )
{
		int PieceVal = PieceValues [ TempBoard.Sq[ m_Sq ] ];
		int bAttack;
		// Attack with least valuable piece
		if ( Color == WHITE) bAttack = DoWhiteAttack( TempBoard.Sq );
	 					else bAttack = DoBlackAttack( TempBoard.Sq );

		if (bAttack == FALSE) return value;

		int Max = value;
		value -=PieceVal;

		if (Color == WHITE) 
			{
			value = SEE (BLACK, value, TempBoard );
			if (value > Max) Max = value;
			}
		if (Color == BLACK) 
			{
			 value = SEE (WHITE, value, TempBoard );
			 if (value < Max) Max = value;
			}
		
		return Max;
}