.486
.MODEL FLAT,C

BPAWN EQU 10
BROOK EQU 13
BQUEEN EQU 14
BKING EQU 15
BKNIGHT EQU 12
BBISHOP EQU 11

WPAWN EQU 2
WROOK EQU 5 
WQUEEN EQU 6
WKING EQU 7
WKNIGHT EQU 4
WBISHOP EQU 3

EMPTY EQU 0

.CODE

AddNormalMoveB PROC NEAR

PUBLIC AddNormalMoveB

           push esi
           push eax
           
           mov esi, dword ptr[edx]       ; esi = Movelist.numoves
           inc dword ptr[edx]            ; Movelist.nummoves += 1
           sub eax, edi                  ; dst 
		   inc esi
           shl eax, 8                    ; dst << 8
           add eax, ecx                  ; add (src + piecenum<<16)
           mov dword ptr[edx + esi * 4 + 212], eax ; 212 + &Movelist to find start of moves
           
           pop eax
           pop esi
           ret

AddNormalMoveB ENDP

AddAttackMoveD PROC NEAR

PUBLIC AddAttackMoveD

           push esi
           push eax
           
           mov esi, dword ptr[edx + 4]   ; esi = Movelist.numAttackmoves
           inc dword ptr[edx + 4]        ; Movelist.numAttackmoves += 1
           sub eax, edi                  ; dst 
		   inc esi
           shl eax, 8                    ; dst << 8
		   add eax, ecx					 ; add (src + piecenum<<16)
           mov dword ptr[edx + esi * 4 + 12], eax ; &Movelist + 12 start of attack moves
           
           pop eax
           pop esi
           ret

AddAttackMoveD ENDP

FindMovesBlackKnightasm PROC NEAR AA:DWORD, BB:DWORD, CC:DWORD, EE:DWORD
PUBLIC FindMovesBlackKnightasm

; edx = Movelist pointer eax = Boardsrc pointer, ecx = src + type << 16, edi = boardstart
; check directions 8, 12, 19, 21, -8, -12, -19, -21
           pusha
		   mov edx, AA
		   mov edi, BB
		   mov eax, CC
		   mov ecx, EE
           
           xor ebx, ebx                  ; 0 out ebx
           add eax, 8
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           jne knight1
           CALL AddNormalMoveB
           jmp knightnext1
           knight1:
           cmp ebx, 8
           jae knightnext1
           CALL AddAttackMoveD
    
           knightnext1:
           add eax, 4
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           jne knight2
           CALL AddNormalMoveB
           jmp knightnext2
           knight2:
           cmp ebx, 8
           jae knightnext2
           CALL AddAttackMoveD
           
           knightnext2:
           add eax, 7
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           jne knight3
           CALL AddNormalMoveB
           jmp knightnext3
           knight3:
           cmp ebx, 8
           jae knightnext3
           CALL AddAttackMoveD
    
           knightnext3:
           add eax, 2
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           jne knight4
           CALL AddNormalMoveB
           jmp knightnext4
           knight4:
           cmp ebx, 8
           jae knightnext4
           CALL AddAttackMoveD
           
           knightnext4:
           sub eax, 29
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           jne knight5
           CALL AddNormalMoveB
           jmp knightnext5
           knight5:
           cmp ebx, 8
           jae knightnext5
           CALL AddAttackMoveD
    
           knightnext5:
           sub eax, 4
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           jne knight6
           CALL AddNormalMoveB
           jmp knightnext6
           knight6:
           cmp ebx, 8
           jae knightnext6
           CALL AddAttackMoveD
           
           knightnext6:
           sub eax, 7
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           jne knight7
           CALL AddNormalMoveB
           jmp knightnext7
           knight7:
           cmp ebx, 8
           jae knightnext7
           CALL AddAttackMoveD
    
           knightnext7:
           sub eax, 2
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           jne knight8
           CALL AddNormalMoveB
           jmp knightnext8
           knight8:
           cmp ebx, 8
           jae knightnext8
           CALL AddAttackMoveD
           
           knightnext8:
           
           popa
           
           ret
           
FindMovesBlackKnightasm ENDP

FindMovesBlackKingasm PROC NEAR AA:DWORD, BB:DWORD, CC:DWORD, EE:DWORD
PUBLIC FindMovesBlackKingasm

; edx = Movelist pointer eax = Boardsrc pointer, ecx = src + type << 16, edi = boardstart
; 1, 9, 10, 11, -1 , -9, -10, -11
           pusha
		   mov edx, AA
		   mov edi, BB
		   mov eax, CC
		   mov ecx, EE
           
           xor ebx, ebx                  ; 0 out ebx
           add eax, 1
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           jne king1
           CALL AddNormalMoveB
           jmp kingnext1
           king1:
           cmp ebx, 8
           jae kingnext1
           CALL AddAttackMoveD
    
           kingnext1:
           add eax, 8
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           jne king2
           CALL AddNormalMoveB
           jmp kingnext2
           king2:
           cmp ebx, 8
           jae kingnext2
           CALL AddAttackMoveD
           
           kingnext2:
           add eax, 1
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           jne king3
           CALL AddNormalMoveB
           jmp kingnext3
           king3:
           cmp ebx, 8
           jae kingnext3
           CALL AddAttackMoveD
    
           kingnext3:
           add eax, 1
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           jne king4
           CALL AddNormalMoveB
           jmp kingnext4
           king4:
           cmp ebx, 8
           jae kingnext4
           CALL AddAttackMoveD
           
           kingnext4:
           sub eax, 12
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           jne king5
           CALL AddNormalMoveB
           jmp kingnext5
           king5:
           cmp ebx, 8
           jae kingnext5
           CALL AddAttackMoveD
    
           kingnext5:
           sub eax, 8
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           jne king6
           CALL AddNormalMoveB
           jmp kingnext6
           king6:
           cmp ebx, 8
           jae kingnext6
           CALL AddAttackMoveD
           
           kingnext6:
           sub eax, 1
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           jne king7
           CALL AddNormalMoveB
           jmp kingnext7
           king7:
           cmp ebx, 8
           jae kingnext7
           CALL AddAttackMoveD
    
           kingnext7:
           sub eax, 1
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           jne king8
           CALL AddNormalMoveB
           jmp kingnext8
           king8:
           cmp ebx, 8
           jae kingnext8
           CALL AddAttackMoveD
           
           kingnext8:
           
           popa
           ret
           
FindMovesBlackKingasm ENDP

FindMovesBlackPawnasm PROC NEAR AA:DWORD, BB:DWORD, CC:DWORD, EE:DWORD
PUBLIC FindMovesBlackPawnasm
           pusha
		   mov edx, AA
		   mov edi, BB
		   mov eax, CC
		   mov ecx, EE

           mov esi, ecx
           and esi, 255     ; esi = movesrc

           xor ebx, ebx                  ; 0 out ebx
           add eax, 10
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           jne pawn1
		   cmp esi, 81
		   ja promo2
           CALL AddNormalMoveB
           jmp pawnnext1
		   promo2:
           CALL AddAttackMoveD
           pawn1:
           add eax, 10                ; So eax will be at the right value
           jmp pawn2                  ; Can't move forward 1, so don't check 2.
    
           pawnnext1:
           add eax, 10
           cmp esi, 41             ; Can only move 2 ahead on 2nd row
           ja pawn2 
           mov bl, byte ptr[eax]
           cmp ebx, EMPTY
           jne pawn2
           CALL AddNormalMoveB

           pawn2:
           pawnnext2:                ; Attack 9
           sub eax, 11 
           mov bl, byte ptr[eax]     
           sub eax, edi
           cmp al, byte ptr[edi + 123] ; en passant
           je pawn3
           cmp ebx, 8                  ; normal capture 
           jae pawn3b
           cmp ebx, EMPTY
           je pawnnext3
           pawn3:
           add eax, edi              ; Back to eax = &square
           CALL AddAttackMoveD
           sub eax, edi

           pawn3b:
           pawnnext3:                ; Attack 11
           add eax, edi
           add eax, 2
           mov bl, byte ptr[eax]
           sub eax, edi  ; en passant
           cmp al, byte ptr[edi + 123]  ; en passant
           je pawn4
           cmp ebx, 8                  ; normal capture 
           jae pawn4b
           cmp ebx, EMPTY
           je pawnnext4
           pawn4:
           add eax, edi            ; Back to eax = &square
           CALL AddAttackMoveD
           jmp pawnnext4
           pawn4b:
        
           pawnnext4:
           
           popa
           ret
           
FindMovesBlackPawnasm ENDP 

                                                ; devalue queens moves?
FindMovesBlackQueenasm PROC NEAR AA:DWORD, BB:DWORD, CC:DWORD, EE:DWORD
PUBLIC FindMovesBlackQueenasm
           pusha
		   mov edx, AA
		   mov edi, BB
		   mov eax, CC
		   mov ecx, EE
           
           mov esi, eax
          
           mov ebx, 1             ; Check direction 1
           mov eax, esi
           
           add eax, ebx           ; while dst = empty loop
           cmp byte ptr[eax], EMPTY
           jne qendloop1
           qagain1:
           CALL AddNormalMoveB
           add eax, ebx
           cmp byte ptr[eax], EMPTY
           je qagain1
           
           qendloop1:              ; attack move?
           mov bl, byte ptr [eax]
           cmp ebx, 8
           jae qnext1
           CALL AddAttackMoveD
           
           qnext1:
           mov ebx, -1             
           mov eax, esi
           
           add eax, ebx           ; while dst = empty loop
           cmp byte ptr[eax], EMPTY
           jne qendloop2
           qagain2:
           CALL AddNormalMoveB
           add eax, ebx
           cmp byte ptr[eax], EMPTY
           je qagain2
           
           qendloop2:
           xor ebx, ebx
           mov bl, byte ptr [eax]
           cmp ebx, 8
           jae qnext2
           CALL AddAttackMoveD
                
         
           qnext2:
           mov ebx, 10             
           mov eax, esi
           
           add eax, ebx           ; while dst = empty loop
           cmp byte ptr[eax], EMPTY
           jne qendloop3
           qagain3:
           CALL AddNormalMoveB
           add eax, ebx
           cmp byte ptr[eax], EMPTY
           je qagain3
           
           qendloop3:              ; Attack Move?
           mov bl, byte ptr [eax]
           cmp ebx, 8
           jae qnext3
           CALL AddAttackMoveD
           
           qnext3:
           mov ebx, -10
           mov eax, esi
           
           add eax, ebx           ; while dst = empty loop
           cmp byte ptr[eax], EMPTY
           jne qendloop4
           qagain4:
           CALL AddNormalMoveB
           add eax, ebx
           cmp byte ptr[eax], EMPTY
           je qagain4
           
           qendloop4:
           xor ebx, ebx
           mov bl, byte ptr [eax]
           cmp ebx, 8
           jae qnext4
           CALL AddAttackMoveD
                 
            
           qnext4:
           mov ebx, 9             
           mov eax, esi
           
           add eax, ebx           ; while dst = empty loop
           cmp byte ptr[eax], EMPTY
           jne qendloop5
           qagain5:
           CALL AddNormalMoveB
           add eax, ebx
           cmp byte ptr[eax], EMPTY
           je qagain5
           
           qendloop5:
           mov bl, byte ptr [eax]
           cmp ebx, 8
           jae qnext5
           CALL AddAttackMoveD
                
           
           qnext5:
           mov ebx, -9             
           mov eax, esi
           
           add eax, ebx           ; while dst = empty loop
           cmp byte ptr[eax], EMPTY
           jne qendloop6
           qagain6:
           CALL AddNormalMoveB
           add eax, ebx
           cmp byte ptr[eax], EMPTY
           je qagain6
           
           qendloop6:
           xor ebx, ebx
           mov bl, byte ptr [eax]
           cmp ebx, 8
           jae qnext6
           CALL AddAttackMoveD
                          
           qnext6:
           mov ebx, 11             
           mov eax, esi
           
           add eax, ebx           ; while dst = empty loop
           cmp byte ptr[eax], EMPTY
           jne qendloop7
           qagain7:
           CALL AddNormalMoveB
           add eax, ebx
           cmp byte ptr[eax], EMPTY
           je qagain7
           
           qendloop7:
           mov bl, byte ptr [eax]
           cmp ebx, 8
           jae qnext7
           CALL AddAttackMoveD
           
           qnext7:
           mov ebx, -11             
           mov eax, esi
           
           add eax, ebx           ; while dst = empty loop
           cmp byte ptr[eax], EMPTY
           jne qendloop8
           qagain8:
           CALL AddNormalMoveB
           add eax, ebx
           cmp byte ptr[eax], EMPTY
           je qagain8
           
           qendloop8:
           xor ebx, ebx
           mov bl, byte ptr [eax]
           cmp ebx, 8
           jae qnext8
           CALL AddAttackMoveD           
           
           qnext8:
           
           popa 
           ret                                                       
           
FindMovesBlackQueenasm ENDP

FindMovesBlackRookasm PROC NEAR AA:DWORD, BB:DWORD, CC:DWORD, EE:DWORD
PUBLIC FindMovesBlackRookasm
           pusha
		   mov edx, AA
		   mov edi, BB
		   mov eax, CC
		   mov ecx, EE

           mov esi, eax
          
           mov ebx, 1             ; Check direction 1
           mov eax, esi
           
           add eax, ebx           ; while dst = empty loop
           cmp byte ptr[eax], EMPTY
           jne rendloop1
           ragain1:
           CALL AddNormalMoveB
           add eax, ebx
           cmp byte ptr[eax], EMPTY
           je ragain1
           
           rendloop1:              ; attack move?
           mov bl, byte ptr [eax]
           cmp ebx, 8
           jae rnext1
           CALL AddAttackMoveD
           
           rnext1:
           mov ebx, -1             
           mov eax, esi
           
           add eax, ebx           ; while dst = empty loop
           cmp byte ptr[eax], EMPTY
           jne rendloop2
           ragain2:
           CALL AddNormalMoveB
           add eax, ebx
           cmp byte ptr[eax], EMPTY
           je ragain2
           
           rendloop2:
           xor ebx, ebx
           mov bl, byte ptr [eax]
           cmp ebx, 8
           jae rnext2
           CALL AddAttackMoveD
                
         
           rnext2:
           mov ebx, 10             
           mov eax, esi
           
           add eax, ebx           ; while dst = empty loop
           cmp byte ptr[eax], EMPTY
           jne rendloop3
           ragain3:
           CALL AddNormalMoveB
           add eax, ebx
           cmp byte ptr[eax], EMPTY
           je ragain3
           
           rendloop3:              ; Attack Move?
           mov bl, byte ptr [eax]
           cmp ebx, 8
           jae rnext3
           CALL AddAttackMoveD
           
           rnext3:
           mov ebx, -10
           mov eax, esi
           
           add eax, ebx           ; while dst = empty loop
           cmp byte ptr[eax], EMPTY
           jne rendloop4
           ragain4:
           CALL AddNormalMoveB
           add eax, ebx
           cmp byte ptr[eax], EMPTY
           je ragain4
           
           rendloop4:
           xor ebx, ebx           
           mov bl, byte ptr [eax]
           cmp ebx, 8
           jae rnext4
           CALL AddAttackMoveD
            
           rnext4:
           
           popa
           ret
                                                 
           
FindMovesBlackRookasm ENDP
 

FindMovesBlackBishopasm PROC NEAR AA:DWORD, BB:DWORD, CC:DWORD, EE:DWORD
PUBLIC FindMovesBlackBishopasm
           pusha
		   mov edx, AA
		   mov edi, BB
		   mov eax, CC
		   mov ecx, EE
           
           mov esi, eax
          
           mov ebx, 9             ; Check direction 1
           mov eax, esi
           
           add eax, ebx           ; while dst = empty loop
           cmp byte ptr[eax], EMPTY
           jne bendloop1
           bagain1:
           CALL AddNormalMoveB
           add eax, ebx
           cmp byte ptr[eax], EMPTY
           je bagain1
           
           bendloop1:              ; attack move?
           mov bl, byte ptr [eax]
           cmp ebx, 8
           jae bnext1
           CALL AddAttackMoveD
           
           bnext1:
           mov ebx, -9
           mov eax, esi
           
           add eax, ebx           ; while dst = empty loop
           cmp byte ptr[eax], EMPTY
           jne bendloop2
           bagain2:
           CALL AddNormalMoveB
           add eax, ebx
           cmp byte ptr[eax], EMPTY
           je bagain2
           
           bendloop2:
           xor ebx, ebx           
           mov bl, byte ptr [eax]
           cmp ebx, 8
           jae bnext2
           CALL AddAttackMoveD
               
           bnext2:
           mov ebx, 11
           mov eax, esi
           
           add eax, ebx           ; while dst = empty loop
           cmp byte ptr[eax], EMPTY
           jne bendloop3
           bagain3:
           CALL AddNormalMoveB
           add eax, ebx
           cmp byte ptr[eax], EMPTY
           je bagain3
           
           bendloop3:              ; Attack Move?
           mov bl, byte ptr [eax]
           cmp ebx, 8
           jae bnext3
           CALL AddAttackMoveD
           
           bnext3:
           mov ebx, -11
           mov eax, esi
           
           add eax, ebx           ; while dst = empty loop
           cmp byte ptr[eax], EMPTY
           jne bendloop4
           bagain4:
           CALL AddNormalMoveB
           add eax, ebx
           cmp byte ptr[eax], EMPTY
           je bagain4
           
           bendloop4:
           xor ebx, ebx
           mov bl, byte ptr [eax]
           cmp ebx, 8
           jae bnext4
           CALL AddAttackMoveD
            
           bnext4:
           
           popa
           ret
           
FindMovesBlackBishopasm ENDP

END

       
