.486
.MODEL FLAT,C

BPAWN EQU 10
BROOK EQU 13
BQUEEN EQU 14
BKING EQU 15
BKNIGHT EQU 12
BBISHOP EQU 11

WPAWN EQU 2
WROOK EQU 5 
WQUEEN EQU 6
WKING EQU 7
WKNIGHT EQU 4
WBISHOP EQU 3

EMPTY EQU 0

.CODE


AddAttackMoveB PROC NEAR

PUBLIC AddAttackMoveB

           push esi
           push eax
           
           mov esi, dword ptr[edx + 4]   ; esi = Movelist.numAttackmoves
           inc dword ptr[edx + 4]        ; Movelist.numAttackmoves += 1
           sub eax, edi                  ; dst 
		   inc esi
           shl eax, 8                    ; dst << 8
		   add eax, ecx					 ; add (src + piecenum<<16)
           mov dword ptr[edx + esi * 4 + 12], eax ; &Movelist + 12 start of attack moves
           
           pop eax
           pop esi
           ret

AddAttackMoveB ENDP

FindAMovesWhiteKnightasm PROC NEAR AA:DWORD, BB:DWORD, CC:DWORD, EE:DWORD
PUBLIC FindAMovesWhiteKnightasm

; edx = Movelist pointer eax = Boardsrc pointer, ecx = src + type << 16, edi = boardstart
; check directions 8, 12, 19, 21, -8, -12, -19, -21
           pusha
		   mov edx, AA
		   mov edi, BB
		   mov eax, CC
		   mov ecx, EE
          
           add eax, 8 
           xor ebx, ebx                  ; 0 out ebx
           cmp byte ptr[eax], 8
           jbe knightnext1
           CALL AddAttackMoveB
    
           knightnext1:
           add eax, 4
           cmp byte ptr[eax], 8
           jbe knightnext2
           CALL AddAttackMoveB
           
           knightnext2:
           add eax, 7
           cmp byte ptr[eax], 8
           jbe knightnext3
           CALL AddAttackMoveB
    
           knightnext3:
           add eax, 2
           cmp byte ptr[eax], 8
           jbe knightnext4
           CALL AddAttackMoveB
           
           knightnext4:
           sub eax, 29
           cmp byte ptr[eax], 8
           jbe knightnext5
           CALL AddAttackMoveB
    
           knightnext5:
           sub eax, 4
           cmp byte ptr[eax], 8
           jbe knightnext6
           CALL AddAttackMoveB
           
           knightnext6:
           sub eax, 7
           cmp byte ptr[eax], 8
           jbe knightnext7
           CALL AddAttackMoveB
    
           knightnext7:
           sub eax, 2
           cmp byte ptr[eax], 8
          jbe knightnext8
           CALL AddAttackMoveB
           
           knightnext8:
           
           popa
           ret
           
FindAMovesWhiteKnightasm ENDP

FindAMovesWhiteKingasm PROC NEAR AA:DWORD, BB:DWORD, CC:DWORD, EE:DWORD
PUBLIC FindAMovesWhiteKingasm


; BUGGY
           pusha
		   mov edx, AA
		   mov edi, BB
		   mov eax, CC
		   mov ecx, EE
           
           xor ebx, ebx                  ; 0 out ebx
           
           add eax, 1
           cmp byte ptr[eax], 8
           jbe kingnext1
           CALL AddAttackMoveB
    
           kingnext1:
           add eax, 8
           cmp byte ptr[eax], 8
           jbe kingnext2
           CALL AddAttackMoveB
           
           kingnext2:
           add eax, 1

           cmp byte ptr[eax], 8
           jbe kingnext3
           CALL AddAttackMoveB
    
           kingnext3:
           add eax, 1
           cmp byte ptr[eax], 8
           jbe kingnext4
           CALL AddAttackMoveB
           
           kingnext4:
           sub eax, 12
           cmp byte ptr[eax], 8
           jbe kingnext5
           CALL AddAttackMoveB
    
           kingnext5:
           sub eax, 8
           cmp byte ptr[eax], 8
           jbe kingnext6
           CALL AddAttackMoveB
           
           kingnext6:
           sub eax, 1
           cmp byte ptr[eax], 8
           jbe kingnext7
           CALL AddAttackMoveB
    
           kingnext7:
           sub eax, 1
           cmp byte ptr[eax], 8
           jbe kingnext8
           CALL AddAttackMoveB
           
           kingnext8:
           
           popa
           ret
           
FindAMovesWhiteKingasm ENDP

FindAMovesWhitePawnasm PROC NEAR AA:DWORD, BB:DWORD, CC:DWORD, EE:DWORD
PUBLIC FindAMovesWhitePawnasm
           pusha
		   mov edx, AA
		   mov edi, BB
		   mov eax, CC
		   mov ecx, EE
                      
           xor ebx, ebx                  ; 0 out ebx

           sub eax, 9 
           mov bl, byte ptr[eax]     
           sub eax, edi              
           cmp al, byte ptr[edi + 123] ; en passant
           je pawn3
           
           cmp ebx, 8                  ; normal capture 
           jbe pawnnext3
           pawn3:
           add eax, edi              ; Back to eax = &square
           CALL AddAttackMoveB
           sub eax, edi

           pawnnext3:                ; Attack -11

           add eax, edi
           sub eax, 2
           mov bl, byte ptr[eax]
           sub eax, edi  ; en passant
           cmp al, byte ptr[edi + 123]  ; en passant
           je pawn4
           
           cmp ebx, 8                   ; normal capture
           jbe pawnnext4
           pawn4:
           add eax, edi            ; Back to eax = &square
           CALL AddAttackMoveB

           pawnnext4:
           
           popa
           ret
           
FindAMovesWhitePawnasm ENDP

                                                ; devalue queens moves?
FindAMovesWhiteQueenasm PROC NEAR AA:DWORD, BB:DWORD, CC:DWORD, EE:DWORD
PUBLIC FindAMovesWhiteQueenasm
           pusha
		   mov edx, AA
		   mov edi, BB
		   mov eax, CC
		   mov ecx, EE
           
           mov esi, eax
          
           mov ebx, 1             ; Check direction 1
           mov eax, esi
           
           qagain1:
           add eax, ebx
           cmp byte ptr[eax], 0
           je qagain1
           
           cmp byte ptr [eax], 8
           jbe qnext1
           CALL AddAttackMoveB
           
           qnext1:
           mov ebx, -1             
           mov eax, esi
           
           qagain2:
           add eax, ebx
           cmp byte ptr[eax], 0
           je qagain2
                 
		   cmp byte ptr [eax], 8
		   jbe qnext2
           CALL AddAttackMoveB
                
         
           qnext2:
           mov ebx, 10             
           mov eax, esi
           
           qagain3:
           add eax, ebx
           cmp byte ptr[eax], 0
           je qagain3
           
		   cmp byte ptr [eax], 8
           jbe qnext3
           CALL AddAttackMoveB
           
           qnext3:
           mov ebx, -10
           mov eax, esi
           
           qagain4:
           add eax, ebx
           cmp byte ptr[eax], 0
           je qagain4
           
           cmp byte ptr [eax], 8
           jbe qnext4
           CALL AddAttackMoveB
            
           qnext4:
           mov ebx, 9             
           mov eax, esi
           
           qagain5:
           add eax, ebx
           cmp byte ptr[eax], 0
           je qagain5
           
           cmp byte ptr [eax], 8
           jbe qnext5
           CALL AddAttackMoveB
                
           
           qnext5:
           mov ebx, -9             
           mov eax, esi
           
           qagain6:
           add eax, ebx
           cmp byte ptr[eax], 0
           je qagain6
           
           cmp byte ptr [eax], 8
           jbe qnext6
           CALL AddAttackMoveB
                          
           qnext6:
           mov ebx, 11             
           mov eax, esi
           
           qagain7:
           add eax, ebx
           cmp byte ptr[eax], 0
           je qagain7
           
           cmp byte ptr [eax], 8
           jbe qnext7
           CALL AddAttackMoveB
           
           qnext7:
           mov ebx, -11             
           mov eax, esi
           
           qagain8:
           add eax, ebx
           cmp byte ptr[eax], 0
           je qagain8
           
		   xor ebx, ebx
           cmp byte ptr [eax], 8
           jbe qnext8
           CALL AddAttackMoveB           
           
           qnext8:
           
           popa  
           ret                                                       
           
FindAMovesWhiteQueenasm ENDP

FindAMovesWhiteRookasm PROC NEAR AA:DWORD, BB:DWORD, CC:DWORD, EE:DWORD
PUBLIC FindAMovesWhiteRookasm
           pusha
		   mov edx, AA
		   mov edi, BB
		   mov eax, CC
		   mov ecx, EE

           mov esi, eax
          
           mov ebx, 1             ; Check direction 1
           mov eax, esi
           
           ragain1:
           add eax, ebx
           cmp byte ptr[eax], 0
           je ragain1
           
           cmp byte ptr [eax], 8
           jbe rnext1
           CALL AddAttackMoveB
           
           rnext1:
           mov ebx, -1             
           mov eax, esi
           
           ragain2:
           add eax, ebx
           cmp byte ptr[eax], 0
           je ragain2
           
		   xor ebx, ebx
           mov bl, byte ptr [eax]
           
           cmp ebx, 8
           jbe rnext2
           CALL AddAttackMoveB
                
           rnext2:
           mov ebx, 10             
           mov eax, esi
           
           ragain3:
           add eax, ebx
           cmp byte ptr[eax], 0
           je ragain3
           
           cmp byte ptr [eax], 8
           jbe rnext3
           CALL AddAttackMoveB
           
           rnext3:
           mov ebx, -10
           mov eax, esi
           
           ragain4:
           add eax, ebx
           cmp byte ptr[eax], 0
           je ragain4
           
           cmp byte ptr [eax], 8
           jbe rnext4
           CALL AddAttackMoveB
            
           rnext4:
           
           popa
           ret
                                               
          
FindAMovesWhiteRookasm ENDP

 
FindAMovesWhiteBishopasm PROC NEAR AA:DWORD, BB:DWORD, CC:DWORD, EE:DWORD
PUBLIC FindAMovesWhiteBishopasm
           pusha
		   mov edx, AA
		   mov edi, BB
		   mov eax, CC
		   mov ecx, EE
           
           mov esi, eax
          
           mov ebx, 9             ; Check direction 1
           mov eax, esi
           
           bagain1:
           add eax, ebx
           cmp byte ptr[eax], 0
           je bagain1
           
           cmp byte ptr [eax], 8
           jbe bnext1
           CALL AddAttackMoveB
           
           bnext1:
           mov ebx, -9
           mov eax, esi
           
           bagain2:
           add eax, ebx
           cmp byte ptr[eax], 0
           je bagain2
         
           cmp byte ptr [eax], 8
           jbe bnext2
           CALL AddAttackMoveB
               
           bnext2:
           mov ebx, 11
           mov eax, esi
           
           bagain3:
           add eax, ebx
           cmp byte ptr[eax], 0
           je bagain3
           
           cmp byte ptr [eax], 8
           jbe bnext3
           CALL AddAttackMoveB
           
           bnext3:
           mov ebx, -11
           mov eax, esi
           
           bagain4:
           add eax, ebx
           cmp byte ptr[eax], 0
           je bagain4
           
           cmp byte ptr [eax], 8
           jbe bnext4
           CALL AddAttackMoveB
            
           bnext4:
           
           popa
           ret
           
FindAMovesWhiteBishopasm ENDP

END

       
