
// GUI Function Definitions
void DisplayText ( char *String);

static void DrawBitmap( HDC hdc, HBITMAP bitmap, int x, int y );
void DrawBoard ( SBoard &board, SBoard &board2, int i);
static BOOL FirstInstance( HINSTANCE );
static BOOL AnyInstance( HINSTANCE, int, LPSTR );

BOOL CALLBACK PawnDlgProc( HWND hwnd, unsigned msg, UINT wparam, LONG lparam );
long CALLBACK WindowProc( HWND, unsigned, UINT, LONG );
BOOL CALLBACK GameDlgProc( HWND hwnd, unsigned msg, UINT wparam, LONG lparam );
void NewGame ( int bDraw );
void NetGameOn ( );
void NetGameOff ( int bClose );
void StartGameBox ( );
void EndGameBox ( );
void UpdateMove ( int bTranscript);
void DisplayTimer ( int WhiteTime, int BlackTime );
void FAR PonderNextMove( void FAR *parm );
void ThinkOfMove ( int nFlags );
int PlayerMove (int sx, int sy, int dx, int dy, int piece );

// GUI Global Data
extern HWND sideHWND, mainhwnd, ChatWnd, NetStartWnd;
extern int g_nBlackTime, g_nWhiteTime;
extern char OppReady, Ready;
extern int g_GameResult, g_bNetGame;
extern char g_cNetColor;
extern int Minutes, Seconds, ELO, g_NetMinutes, g_NetSeconds;
extern char sUserName [66];
extern char sOppName  [66];
extern char sConnectIP[66];
extern char g_sNetWhite [66], g_sNetBlack[66];
extern char *g_sSlow;

extern int bExtendChecks, bAlwaysQuiesce, bUseNull,  bExperiment, g_ponder, bPonder, bEvalWhite;
extern int g_ponderSrc, g_ponderDst;
extern int bDisplayInfo, bHashing;
extern SBoard g_StartBoard;
extern int MaxAhead, g_nFlags, g_bAlwaysWait, g_bWinBoard;
extern unsigned int  g_nMaxNodes;
extern g_bICC, g_bWinBoard;
extern HANDLE hEngineReady;
