extern Movestruct *MoveStack;
extern SBoard *BoardStack;

extern int SearchDepth, flipboard , thinking, bAcceptDraw;
extern unsigned char PlayerCOLOR;
extern float Thinktime, fPanicTime;
extern int  stopthinking, g_SearchColor;

extern int PV	 [(MAXDEPTH+1)][(MAXDEPTH+1)];
extern unsigned int WPHashSq [128];
extern unsigned int BPHashSq [128];

// Function Definitions
int CompMove (SBoard& Board, int nFlags, int MaxAhead);
short ABSearch(int color, int ahead, int depth, short alpha, short beta,  int &bestmove, int bAfterNull);

void DisplayTTEntry ();
void Clear_Hash (void);
void Create_HashFunction ( );
unsigned int Hash_Board2 ( SBoard &Board);
unsigned int Hash_Board (SBoard &Board);
unsigned int Pawn_HashBoard (SBoard &Board); // In Evaluate.cpp

void GetPVString ( char *buffer, int format );
void PlayPV ( void );
void DisplayPV ( void );
void DisplaySearchInfo (void);
void DisplayFinalSearchInfo ( int nEval, int SearchDepth, char cOcolor, int nBestMove );
void GetEvalString ( char *sEvalString, int nEval);
void GetMoveString (char sBuffer[], int src, int dst, SBoard const &Board);
int CheckGameOver ( SBoard &Board, int bPopUps, int &GameResult );
int IsMate ( SBoard &Board, char Color);
void SetHashSizeBits ( int nBits );
int IsPanic ( );
void InitSearchGlobals ( SBoard &Board );
void SetThinkTime (float nCompTm, int nMoves, int nSecs );
void UpdateDisplayInfo ( int i, int MMove, int Max, int bestmove );

// Draw
//void AddRepBoard ( const unsigned int hashV, const SBoard &Board );
void AddRepBoard ( SBoard &Board);
int DrawByRepetition ( unsigned int hashV, const SBoard &Board);
int DrawByRepetition ( SBoard &Board);


// From Winboard.cpp
void wbSendMove( );
void wbSendThinking(int ply, int eval, unsigned long tm, unsigned int nodes, int bPV, int bFailHigh, int bFinishedDepth);
void wbTestSendResult ( SBoard &Board );
void wbSendResult(char *sResult, char *sWhy);
void wbSendThinking2( int bFinishedDepth );
int wbResign ( int nEval );

